| Qore RestSchemaValidator Module Reference 2.2.1

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | Protected Member Functions | Private Member Functions | List of all members
RestSchemaValidator::NullRestSchemaValidator Class Reference

null REST validator; no schema is used but default serialization and deserialization is performed More...

Inheritance diagram for RestSchemaValidator::NullRestSchemaValidator:
[legend]

## Public Member Functions
| constructor ()
| Creates the object without a logger.
| constructor (Logger::LoggerInterface logger)
| Creates the object with the given logger.
bool | managesUriPath ()
| returns True if the provider manages the URI path
Public Member Functions inherited from RestSchemaValidator::AbstractRestSchemaValidator
| constructor ()
| Creates the object without a logger.
| constructor (Logger::LoggerInterface logger)
| Creates the object with the given logger.
string | getBasePath ()
| returns the base path prefix for all requests in this schema
DataProvider::AbstractDataProvider | getDataProvider (HTTPClient rest)
| returns a data provider object for this connection, if supported by any REST schema validator object
hash< RestExampleRequestInfo > | getExampleRequest (string method, string path, *softlist< string > content_types)
| returns a hash of example message information for the given request
hash< RestExampleResponseInfo > | getExampleResponse (string method, string path, int code, *softlist< string > content_types)
| returns a hash of example message information for the given request
string | getHash ()
| returns a unique hash for the schema that can be used to compare schemas
hash< string, list< string > > | getPathOperationHash ()
| returns a hash of URI paths as keys with values as lists of supported HTTP methods
hash< RestQoreExampleCodeInfo > | getQoreExampleRequest (string method, string path)
| returns a hash of example Qore code for the given request
hash< RestQoreExampleCodeInfo > | getQoreExampleResponse (string method, string path, int code)
| returns example Qore code for the given response
string | getTargetUrl ()
| returns the target URL for the schema
*TimeZone | getTimeZoneLocale ()
| Returns the time zone locale used for serialization / deserialization.
bool | managesUriPath ()
| returns True if the provider manages the URI path
hash< RestRequestServerInfo > | parseRequest (string method, string path, *data http_body, reference< hash< auto > > headers)
| processes and parses a client request and returns the deserialized message body (if any)
hash< RestResponseClientInfo > | parseResponse (string method, string path, int code, *data response_body, hash< auto > hdr)
| parses and validates the response from the server and returns a hash of the processed info
hash< RestRequestClientInfo > | processRequest (string method, string path, auto body, *hash< auto > headers, *softlist< string > content_types)
| processes a client-side REST request and returns a hash that can be used to make the outgoing client-side HTTP request
hash< HttpResponseInfo > | processResponse (string method, string path, int code, auto response_body, *hash< auto > headers, *softlist< string > content_types)
| Processes a REST response with a serialized message body.
| setBasePath (string basePath)
| overrides the basePath value
| setTimeZoneLocale (*TimeZone tz)
| Allows the time zone locale to be set for serialization / deserialization.

## Public Attributes
const | DataDeserializationSupport = ...
| Data deserialization support MIME types to codes and de/serialization functions.
const | DataSerializationSupport = ...
| Data serialization support mapping codes to MIME types and de/serialization functions.
const | NullSchemaHashStr = "<null rest schema>"
| a unique hash for the null schema

## Protected Member Functions
string | getBasePathImpl ()
| returns the base path prefix for all requests in this schema
hash< RestExampleRequestInfo > | getExampleRequestImpl (string method, string path, *softlist< string > content_types)
| returns a hash of example message information for the given request
hash< RestExampleResponseInfo > | getExampleResponseImpl (string method, string path, int code, *softlist< string > content_types)
| returns a hash of example message information for the given request
string | getHashImpl ()
| returns a unique hash for the schema that can be used to compare schemas
hash< string, list< string > > | getPathOperationHashImpl ()
| returns a hash of URI paths as keys with values as lists of supported HTTP methods
hash< RestQoreExampleCodeInfo > | getQoreExampleRequestImpl (string method, string path)
| returns a hash of example Qore code for the given request
hash< RestQoreExampleCodeInfo > | getQoreExampleResponseImpl (string method, string path, int code)
| returns example Qore code for the given response
string | getTargetUrlImpl ()
| returns the target URL for the schema
*TimeZone | getTimeZoneLocaleImpl ()
| Returns the time zone locale used for serialization / deserialization.
hash< RestRequestServerInfo > | parseRequestImpl (string method, string path, *data http_body, reference< hash > headers)
| processes and parses a client request and returns the deserialized message body (if any)
hash< RestResponseClientInfo > | parseResponseImpl (string method, string path, int code, *data response_body, hash< auto > hdr)
| parses and validates the response from the server and returns a hash of the processed info
hash< RestRequestClientInfo > | processRequestImpl (string method, string path, auto body, *hash< auto > headers, *softlist< string > content_types)
| processes a client-side REST request and returns a hash that can be used to make the outgoing client-side HTTP request
hash< HttpResponseInfo > | processResponseImpl (string method, string path, int code, auto response_body, *hash< auto > headers, *softlist< string > content_types)
| processes a REST response with a serialized message body, validates any response data against schema definitions if possible
| setBasePathImpl (string basePath)
| overrides the basePath value
| setTimeZoneLocaleImpl (*TimeZone tz)
| Allows the time zone locale to be set for serialization / deserialization.
Protected Member Functions inherited from RestSchemaValidator::AbstractRestSchemaValidator
abstract string | getBasePathImpl ()
| returns the base path prefix for all requests in this schema
DataProvider::AbstractDataProvider | getDataProviderImpl (HTTPClient rest)
| returns a data provider object for this connection, if supported by any REST schema validator object
abstract hash< RestExampleRequestInfo > | getExampleRequestImpl (string method, string path, *softlist< string > content_types)
| returns a hash of example message information for the given request
abstract hash< RestExampleResponseInfo > | getExampleResponseImpl (string method, string path, int code, *softlist< string > content_types)
| returns a hash of example message information for the given request
abstract string | getHashImpl ()
| returns a unique hash for the schema that can be used to compare schemas
abstract hash< string, list< string > > | getPathOperationHashImpl ()
| returns a hash of URI paths as keys with values as lists of supported HTTP methods
abstract hash< RestQoreExampleCodeInfo > | getQoreExampleRequestImpl (string method, string path)
| returns a hash of example Qore code for the given request
abstract hash< RestQoreExampleCodeInfo > | getQoreExampleResponseImpl (string method, string path, int code)
| returns example Qore code for the given response
abstract string | getTargetUrlImpl ()
| returns the target URL for the schema
abstract *TimeZone | getTimeZoneLocaleImpl ()
| Returns the time zone locale used for serialization / deserialization.
abstract hash< RestRequestServerInfo > | parseRequestImpl (string method, string path, *data http_body, reference< hash > headers)
| processes and parses a client request and returns the deserialized message body (if any)
abstract hash< RestResponseClientInfo > | parseResponseImpl (string method, string path, int code, *data response_body, hash< auto > hdr)
| parses and validates the response from the server and returns a hash of the processed info
abstract hash< RestRequestClientInfo > | processRequestImpl (string method, string path, auto body, *hash< auto > headers, *softlist< string > content_types)
| processes a client-side REST request and returns a hash that can be used to make the outgoing client-side HTTP request
abstract hash< HttpResponseInfo > | processResponseImpl (string method, string path, int code, auto response_body, *hash< auto > headers, *softlist< string > content_types)
| processes a REST response with a serialized message body, validates any response data against schema definitions if possible
abstract | setBasePathImpl (string basePath)
| overrides the basePath value
abstract | setTimeZoneLocaleImpl (*TimeZone tz)
| Allows the time zone locale to be set for serialization / deserialization.

## Private Member Functions
bool | checkResponseContentTypeHeader (reference< hash< HttpResponseInfo > > resp, auto body, *hash< auto > headers, *softlist< string > content_types)
| Check if the headers contain a content-type header which is accepted and if so, modify the response hash.

## Detailed Description

null REST validator; no schema is used but default serialization and deserialization is performed

## Member Function Documentation

## ◆ checkResponseContentTypeHeader()

bool RestSchemaValidator::NullRestSchemaValidator::checkResponseContentTypeHeader | ( | reference< hash< HttpResponseInfo > > | resp,
|  | auto | body,
|  | *hash< auto > | headers,
|  | *softlist< string > | content_types )
| private

Check if the headers contain a content-type header which is accepted and if so, modify the response hash.

Parameters

  resp | response hash
  body | response body data (if any)
  headers | HTTP headers to include in the response
  content_types | the accepted MIME types in order of preference

Returns
  whether the headers contained a `Content-Type` header and the rv was modified

Note
  if there are more `Content-Type` headers, then False is returned and response is not modified

## ◆ getBasePathImpl()

string RestSchemaValidator::NullRestSchemaValidator::getBasePathImpl | ( |  | ) |
| protected

returns the base path prefix for all requests in this schema

Returns
  the base path prefix for all requests in this schema

## ◆ getExampleRequestImpl()

hash< RestExampleRequestInfo > RestSchemaValidator::NullRestSchemaValidator::getExampleRequestImpl | ( | string | method,
|  | string | path,
|  | *softlist< string > | content_types )
| protected

returns a hash of example message information for the given request

Parameters

  method | the HTTP method (case insensitive)
  path | the URI path of the request
  content_types | the desired MIME types for serialization in order of preference; if none are usable then an exception is thrown

Returns
  a RestExampleRequestInfo of example message information for the given request

## ◆ getExampleResponseImpl()

hash< RestExampleResponseInfo > RestSchemaValidator::NullRestSchemaValidator::getExampleResponseImpl | ( | string | method,
|  | string | path,
|  | int | code,
|  | *softlist< string > | content_types )
| protected

returns a hash of example message information for the given request

Parameters

  method | the HTTP method of the original request (case insensitive)
  path | the URI path of the original request
  code | the HTTP response code of the response
  content_types | the desired MIME types for serialization in order of preference; if none are usable then an exception is thrown

Returns
  a RestExampleResponseInfo hash giving example response message info

## ◆ getHashImpl()

string RestSchemaValidator::NullRestSchemaValidator::getHashImpl | ( |  | ) |
| protected

returns a unique hash for the schema that can be used to compare schemas

Returns
  a unique hash for the schema that can be used to compare schemas

Since
  RestSchemaValidator 2.0

## ◆ getPathOperationHashImpl()

hash< string, list< string > > RestSchemaValidator::NullRestSchemaValidator::getPathOperationHashImpl | ( |  | ) |
| protected

returns a hash of URI paths as keys with values as lists of supported HTTP methods

Returns
  a hash of URI paths as keys with values as lists of supported HTTP methods

## ◆ getQoreExampleRequestImpl()

hash< RestQoreExampleCodeInfo > RestSchemaValidator::NullRestSchemaValidator::getQoreExampleRequestImpl | ( | string | method,
|  | string | path )
| protected

returns a hash of example Qore code for the given request

Parameters

  method | the HTTP method (case insensitive)
  path | the URI path of the request

Returns
  a RestQoreExampleCodeInfo hash giving example Qore code to generate the given request message

## ◆ getQoreExampleResponseImpl()

hash< RestQoreExampleCodeInfo > RestSchemaValidator::NullRestSchemaValidator::getQoreExampleResponseImpl | ( | string | method,
|  | string | path,
|  | int | code )
| protected

returns example Qore code for the given response

Parameters

  method | the HTTP method of the original request (case insensitive)
  path | the URI path of the original request
  code | the HTTP response code of the response

Returns
  a RestQoreExampleCodeInfo hash giving example Qore code to generate the given response message

## ◆ getTargetUrlImpl()

string RestSchemaValidator::NullRestSchemaValidator::getTargetUrlImpl | ( |  | ) |
| protected

returns the target URL for the schema

Returns
  the target URL for the schema

Exceptions

  MISSING-TARGET-URL | no target URL provided for the schema

## ◆ getTimeZoneLocaleImpl()

*TimeZone RestSchemaValidator::NullRestSchemaValidator::getTimeZoneLocaleImpl | ( |  | ) |
| protected

Returns the time zone locale used for serialization / deserialization.

Returns
  the time zone locale to set

Since
  RestSchemaValidator 2.1.3

## ◆ managesUriPath()

bool RestSchemaValidator::NullRestSchemaValidator::managesUriPath | ( |  | ) |

returns True if the provider manages the URI path

This method returns False

## ◆ parseRequestImpl()

hash< RestRequestServerInfo > RestSchemaValidator::NullRestSchemaValidator::parseRequestImpl | ( | string | method,
|  | string | path,
|  | *data | http_body,
|  | reference< hash > | headers )
| protected

processes and parses a client request and returns the deserialized message body (if any)

Parameters

  method | the HTTP method (case-insensitive)
  path | the URI path with any query arguments
  http_body | the serialized message body
  headers | a reference to the hash of HTTP headers received; any default header values to be assumed by the server for the request will be added here

Returns
  a RestRequestServerInfo hash of request information

Exceptions

  DESERIALIZATION-ERROR | the request body could not be deserialized, results in a `400 Bad Request` response returned to the caller
  SCHEMA-VALIDATION-ERROR | this exception should be thrown if there is a validation error in the request so that a `400 Bad Request` response can be returned to the caller
  INVALID-METHOD | invalid HTTP method for the request; the `arg` argument should have a list of acceptable HTTP methods for this request

## ◆ parseResponseImpl()

hash< RestResponseClientInfo > RestSchemaValidator::NullRestSchemaValidator::parseResponseImpl | ( | string | method,
|  | string | path,
|  | int | code,
|  | *data | response_body,
|  | hash< auto > | hdr )
| protected

parses and validates the response from the server and returns a hash of the processed info

Parameters

  method | the HTTP method (case insensitive)
  path | the URI path of the original request (without any query arguments)
  code | the HTTP response code
  response_body | the HTTP response body data (if any)
  hdr | as hash of HTTP headers received

Exceptions

  DESERIALIZATION-ERROR | the request body could not be deserialized or had an invalid `Content-Type`

## ◆ processRequestImpl()

hash< RestRequestClientInfo > RestSchemaValidator::NullRestSchemaValidator::processRequestImpl | ( | string | method,
|  | string | path,
|  | auto | body,
|  | *hash< auto > | headers,
|  | *softlist< string > | content_types )
| protected

processes a client-side REST request and returns a hash that can be used to make the outgoing client-side HTTP request

Parameters

  method | the HTTP method (case-insensitive)
  path | the URI path with any query arguments
  body | the unserialized message body data
  headers | any headers to include in the request; note that the `Content-Type` header should not be sent here as it will be overridden when the message is serialized
  content_types | the desired MIME types for serialization in order of preference; if none are usable then an exception is thrown

Returns
  a RestRequestClientInfo hash with information about the request

Exceptions

  SERIALIZATION-ERROR | unsupported message body MIME type requested or missing serialization module

## ◆ processResponseImpl()

hash< HttpResponseInfo > RestSchemaValidator::NullRestSchemaValidator::processResponseImpl | ( | string | method,
|  | string | path,
|  | int | code,
|  | auto | response_body,
|  | *hash< auto > | headers,
|  | *softlist< string > | content_types )
| protected

processes a REST response with a serialized message body, validates any response data against schema definitions if possible

Parameters

  method | the HTTP method of the original request
  path | the URI path of the original request (without query arguments)
  code | the HTTP response code
  response_body | the response body data (if any)
  headers | HTTP headers to include in the response; note that if this value contains a `Content-Type` key, this type will be used for the response serialization if it is supported and if the client can accept it, otherwise an `ACCEPT-ERROR` exception is raised resulting in a `406 Not Acceptable` error being returned to the client
  content_types | the desired MIME types for serialization in order of preference; if none are usable then an exception is thrown; if this argument is not present, then json is preferred over yaml

Returns
  an HttpResponseInfo hash for the response

Exceptions

  ACCEPT-ERROR | the response body could not be serialized because the client does not accept a supported type; results in a `406 Not Acceptable` error being returned to the client
  SERIALIZATION-ERROR | the response body could not be serialized due to an error

Note
  <a href="http://www.w3.org/Protocols/rfc2616/rfc2616-sec14.html>RFC 2616 section 14</a>: If an \c Accept header field is present, and if the server cannot send a response which is acceptable according to the combined Accept field value, then the server SHOULD send a 406 (not acceptable) response. To ensure this happens, if an \c Accept error of this nature occurs in this call, an \c "ACCEPT-ERROR" must be thrown

## ◆ setBasePathImpl()

RestSchemaValidator::NullRestSchemaValidator::setBasePathImpl | ( | string | basePath | ) |
| protected

overrides the basePath value

Parameters

  basePath | the new base path value; use an empty string here to clear the basePath

## ◆ setTimeZoneLocaleImpl()

RestSchemaValidator::NullRestSchemaValidator::setTimeZoneLocaleImpl | ( | *TimeZone | tz | ) |
| protected

Allows the time zone locale to be set for serialization / deserialization.

Parameters

  tz | the time zone locale to set

Since
  RestSchemaValidator 2.1.3

## Member Data Documentation

## ◆ NullSchemaHashStr

const RestSchemaValidator::NullRestSchemaValidator::NullSchemaHashStr = "<null rest schema>"

a unique hash for the null schema

Since
  RestSchemaValidator 2.0